
#include "stdafx.h"
#include <PDF/PDFNet.h>
#include <PDF/ElementReader.h>
#include <PDF/ElementWriter.h>
#include <PDF/ElementBuilder.h>
#include <PDF/Element.h>
#include <iostream>

using namespace pdftron;
using namespace PDF;
using namespace SDF;
using namespace std;

char *src_pdf_path = "C:\\clipping1.pdf";
char *tar_pdf_path = "C:\\target2.pdf";
vector <Element> el_list;


void ReadPDF()
{
		// Read PDF
		ElementReader page_reader;
		Element element;
		PDFDoc doc(src_pdf_path);
		doc.InitSecurityHandler();
		Page page = doc.GetPage(1);

		page_reader.Begin(page);

		while ((element = page_reader.Next()) != NULL) 	// Read page contents
		{
			el_list.push_back(element);
		}
		page_reader.End();

}

void WritePDF()
{
		// Write new pdf
		ElementBuilder eb;
		Element new_element;
		PDFDoc tar_doc;
		ElementWriter writer;
		Page new_page = tar_doc.PageCreate(Rect(0, 0, 612, 794));
		writer.Begin(new_page);

		int i, icnt = el_list.size();
		for(i=0;i<icnt;i++) {
			eb.Reset();
			new_element = el_list[i];
			writer.WritePlacedElement(new_element);
		}
		writer.End();  
		tar_doc.PagePushBack(new_page);
		tar_doc.Save(tar_pdf_path, SDFDoc::e_remove_unused, NULL);

}
int _tmain(int argc, _TCHAR* argv[])
{
	int ret = 0;
	PDFNet::Initialize();

	try
	{
		ReadPDF();
		WritePDF();
		
		cout << "Done." << endl;
	}
	catch(Common::Exception& e)
	{
		cout << e << endl;
		ret = 1;
	}
	catch(...)
	{
		cout << "Unknown Exception" << endl;
		ret = 1;
	}

	PDFNet::Terminate();
	return ret;
}
